/***********************************************************************\
*                          __   ______  _____ __                        *
*                   __ _  / /__<  / _ )/ __(_) /__ ___                  *
*                  /  ' \/  '_// / _  / _// / / -_|_-<                  *
*                 /_/_/_/_/\_\/_/____/_/ /_/_/\__/___/                  *
*                                                                       *
*  -------------------------------------------------------------------  *
*  This file is a part of mk1BFiles                                     *
*                                                                       *
*  mk1BFiles is free software; you can redistribute it and/or           *
*  modify it under the terms of the GNU General Public License          *
*  as published by the Free Software Foundation; either version 3       *
*  of the License, or (at your option) any later version.               *
*                                                                       *
*  This program is distributed in the hope that it will be useful,      *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of       *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
*  GNU General Public License for more details.                         *
*                                                                       *
*  You should have received a copy of the GNU General Public License    *
*  along with this program; if not, write to the Free Software          *
*  Foundation, Inc., 51 Franklin Street, Fifth Floor,                   *
*  Boston, MA  02110-1301, USA.                                         *
*                                                                       *
*  -------------------------------------------------------------------  *
*  Copyright (C) 2010, Clercin guillaume <clercin.guillaume@gmail.com>  *
*  Last modified: Wed, 25 Aug 2010 23:18:38 +0200                       *
\***********************************************************************/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "display.h"

static int width = 78;

__attribute__ ((constructor))
static void initDisplay() {
    char * w = getenv("COLUMNS");
    if (w)
        width = atoi(w);
}

void clean(unsigned int sync) {
	char buffer[width];
	memset(buffer, ' ', width - 2);
	buffer[0] = '\r';
	buffer[width - 2] = '\r';
	buffer[width - 1] = '\0';
	dprintf(1, buffer);
	if (sync)
		fsync(1);
}

void mkPrint(const char * data) {
	dprintf(1, data);
	fsync(1);
}

void mkPrintf(const char * data, ...) {
	va_list va;
	va_start(va, data);

	vdprintf(1, data, va);
	fsync(1);

	va_end(va);
}

